## spring 104.0+dfsg

=== CMakeLists.txt ===
# CMake 2.8.10
# + adds support for CMAKE_CXX_COMPILER_ID (which is ignored with older cmake)
cmake_minimum_required(VERSION 2.8.11)


SET(CMAKE_MODULES_SPRING "${CMAKE_CURRENT_SOURCE_DIR}/rts/build/cmake")
LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_MODULES_SPRING}")

# enable flag overrides for compilers
set(CMAKE_USER_MAKE_RULES_OVERRIDE "${CMAKE_MODULES_SPRING}/OverrideFlags.cmake")

project(Spring)

# dummy so that qtcreator shows all files (even those of windows)
if(CMAKE_VERSION VERSION_GREATER 3.1.2)
	add_library(platform_sources EXCLUDE_FROM_ALL "")
endif()

# includes rts/build/cmake/Util.cmake & rts/build/cmake/PreferStaticLibs.cmake
INCLUDE(Util)
INCLUDE(PreferStaticLibs)

CheckMinCMakeVersion(CUSTOM_TARGET_SOURCES_SUPPORT 2 6 3)


# check for minimal gcc version
set(MIN_GCC_VER "4.8")
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
	if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "${MIN_GCC_VER}")
		message(FATAL_ERROR "gcc >=${MIN_GCC_VER} required")
	else()
		message(STATUS "gcc ${CMAKE_CXX_COMPILER_VERSION} detected")
	endif()
endif()

# set some internal vars

if(NOT "${CMAKE_C_FLAGS}" STREQUAL "")
	Message(WARNING "Using custom C_FLAGS: ${CMAKE_C_FLAGS} this build will very likely not sync in online mode!")
endif()

if(NOT "${CMAKE_CXX_FLAGS}" STREQUAL "")
	Message(WARNING "Using custom CXX_FLAGS: ${CMAKE_CXX_FLAGS} this build will very likely not sync in online mode!")
endif()

set (CUSTOM_COMPILER_DEFINITIONS "" CACHE STRING "Custom flags can be defined here")
if    (CUSTOM_COMPILER_DEFINITIONS)
	add_definitions(${CUSTOM_COMPILER_DEFINITIONS})
endif (CUSTOM_COMPILER_DEFINITIONS)


### set the default build type
if    (NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RELWITHDEBINFO CACHE STRING
		"Choose the type of build, options are: RELWITHDEBINFO DEBUG RELEASE PROFILE"
		FORCE)
endif (NOT CMAKE_BUILD_TYPE)

string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPPER)
if(${CMAKE_BUILD_TYPE_UPPER} MATCHES "^DEBUG")
	set(DEBUG_BUILD TRUE)
else()
	set(DEBUG_BUILD FALSE)
endif()

if(DEBUG_BUILD)
	set(JAVA_COMPILE_FLAG_CONDITIONAL "-g:lines,source,vars")
else()
	set(JAVA_COMPILE_FLAG_CONDITIONAL "-g:lines,source")
endif()


# Tell windows to pass arguments around in @response files
# (32k arg limit workaround)
if    (WIN32)
	SET(CMAKE_C_USE_RESPONSE_FILE_FOR_OBJECTS 1)
	SET(CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS 1)
endif (WIN32)


# XCode
if    (APPLE)
	option(MACOSX_BUNDLE "Compile spring to work as a Bundle.app" TRUE)
	add_definitions(${PIC_FLAG})
	if    (MACOSX_BUNDLE)
		add_definitions(-DMACOSX_BUNDLE)
	endif (MACOSX_BUNDLE)
else  (APPLE)
	set(MACOSX_BUNDLE FALSE)
endif (APPLE)

### Compiler flags and defines based on build type
INCLUDE(TestCXXFlags)

## 32bit or 64bit?
set(MARCH_FLAG ${MARCH} CACHE STRING "CPU optimization (use i686 for generic optimization)")
if    (CMAKE_SIZEOF_VOID_P EQUAL 8)
	set(MARCH_BITS 64 CACHE INTERNAL "" FORCE)
else  (CMAKE_SIZEOF_VOID_P EQUAL 8)
	set(MARCH_BITS 32 CACHE INTERNAL "" FORCE)
endif (CMAKE_SIZEOF_VOID_P EQUAL 8)

Message(STATUS "Building Spring on ${MARCH_BITS}bit environment")
set(BUILD_BITS "${MARCH_BITS}" CACHE STRING "Target arch machine type")
Message(STATUS "Targetting ${BUILD_BITS}bit")


### Install paths (relative to CMAKE_INSTALL_PREFIX)
if    (UNIX AND NOT MINGW)
	set(BINDIR  "bin"                CACHE STRING "Where to install binaries")
	set(LIBDIR  "lib"                CACHE STRING "Where to install libraries")
	set(MANDIR  "share/man"          CACHE STRING "Where to install man pages")
	set(DOCDIR  "share/doc/spring-VERSION" CACHE STRING "Where to install basic project documentation (README, LICENSE, etc.)") # TODO set correct version here, and re-enable userdocs in doc/CMakeLists.txt
	set(DATADIR "share/games/spring" CACHE STRING "Where to install game content")

	set(APPLICATIONS_DIR "share/applications" CACHE STRING "Where to install desktop files")
	set(PIXMAPS_DIR      "share/pixmaps"      CACHE STRING "Where to install icons")
	set(MIME_DIR         "share/mime"         CACHE STRING "Where MIME definitions are located")
else  (UNIX AND NOT MINGW)
	set(BINDIR  "." CACHE STRING "Where to install binaries")
	set(LIBDIR  "." CACHE STRING "Where to install libraries")
	set(DOCDIR  "doc" CACHE STRING "Where to install basic project documentation (README, LICENSE, etc.)")
	set(DATADIR "." CACHE STRING "Where to install game content")

	if    (NOT MINGWLIBS)
		if(MSVC)
			set(MINGWLIBS ${CMAKE_SOURCE_DIR}/vclibs CACHE PATH "Location of the vclibs package")
		else(MSVC)
			if(BUILD_BITS EQUAL 32)
				set(MINGWLIBS ${CMAKE_SOURCE_DIR}/mingwlibs CACHE PATH "Location of the mingwlibs package")
			else(BUILD_BITS EQUAL 32)
				set(MINGWLIBS ${CMAKE_SOURCE_DIR}/mingwlibs64 CACHE PATH "Location of the mingwlibs package")
			endif(BUILD_BITS EQUAL 32)
		endif(MSVC)
	endif ()
	if    (EXISTS "${MINGWLIBS}" AND IS_DIRECTORY "${MINGWLIBS}")
		# MinGW needs an additional library, mwindows
		# It's total link flags should look like -lmingw32 -lSDL2main -lSDL2 -lmwindows
		# (Actually on second look, I think it only needs one of the m* libraries.)
		if(NOT MSVC)
			SET(MINGW32_LIBRARY mingw32 CACHE STRING "mwindows for MinGW")
		endif(NOT MSVC)
		set(SDL2_INCLUDE_DIR "${MINGWLIBS}/include/SDL2")
		set(CMAKE_PREFIX_PATH ${MINGWLIBS})
		include_directories(${MINGWLIBS}/include)
		set(CMAKE_LIBRARY_PATH ${MINGWLIBS}/dll ${MINGWLIBS}/lib)

		# some cross-compile fixes
		set(CMAKE_FIND_ROOT_PATH ${MINGWLIBS} ${CMAKE_FIND_ROOT_PATH})
		set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
		set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
	else()
		MESSAGE(WARNING "Compiling for windows. MINGWLIBS '${MINGWLIBS}' is not a valid directory, trying system libs")
	endif ()


	add_definitions(-D_WIN32_WINNT=0x502) ## vista is minimum due to InterlockedIncrement64
	add_definitions(-D__USE_MINGW_ANSI_STDIO=1) ## use __mingw_sprintf instead of __builtin_sprintf (it's used by lua in a synced way, and builtin doesn't sync)


	if(MSVC)
		add_definitions(-DBOOST_ALL_NO_LIB -DNOMINMAX -DWIN32_LEAN_AND_MEAN)
		set(Boost_USE_STATIC_LIBS ON)
		set(GLEW_STATIC ON)
		set(EXE_FLAGS WIN32)
	else()
		INCLUDE_DIRECTORIES(rts/lib/mingw-std-threads)
	endif()
endif (UNIX AND NOT MINGW)

## Artificial Intelligence
# In theory, it should be possible to set this to LIBDIR instead
# (next two are relative to CMAKE_INSTALL_PREFIX)
set(AI_LIBS_DIR "${DATADIR}"     CACHE STRING "Where to install Skirmish AI libraries")
set(AI_DATA_DIR "${AI_LIBS_DIR}" CACHE STRING "Where to install Skirmish AI additional files (eg. configuration)")
set(AI_TYPES    "ALL"            CACHE STRING "Which AI Interfaces (and Skirmish AIs using them) to build [ALL|NATIVE|JAVA|NONE]")

## DataDirs
set(BUILTIN_DATADIRS "")
if    (NOT WIN32 AND NOT MACOSX_BUNDLE)
	set(SPRING_DATADIR CACHE STRING "Path to game content (in addition to /etc/spring/datadir)")
	set(SPRING_DATADIR_INTERNAL "")
	if    (SPRING_DATADIR)
		set(SPRING_DATADIR_INTERNAL "${SPRING_DATADIR}${PATH_DELIM_T}")
	endif (SPRING_DATADIR)
	if    (CMAKE_INSTALL_PREFIX)
		set(SPRING_DATADIR_INTERNAL "${SPRING_DATADIR_INTERNAL}${CMAKE_INSTALL_PREFIX}${PATH_SEP_T}${DATADIR}")
	endif (CMAKE_INSTALL_PREFIX)
	set(BUILTIN_DATADIRS "${SPRING_DATADIR_INTERNAL}")
endif (NOT WIN32 AND NOT MACOSX_BUNDLE)
if    (NOT "${AI_LIBS_DIR}" STREQUAL "${DATADIR}")
	# If the AI library dir is not the same as the normal data dir,
	# add it to the internal list of data dirs
	set(BUILTIN_DATADIRS "${BUILTIN_DATADIRS}${PATH_DELIM_T}${CMAKE_INSTALL_PREFIX}${PATH_SEP_T}${AI_LIBS_DIR}")
endif (NOT "${AI_LIBS_DIR}" STREQUAL "${DATADIR}")
if    (NOT "${AI_DATA_DIR}" STREQUAL "${DATADIR}" AND NOT "${AI_DATA_DIR}" STREQUAL "${AI_LIBS_DIR}")
	# If the AI data dir is not the same as the normal data dir
	# nor the AI library dir, add it to the internal list of data dirs
	set(BUILTIN_DATADIRS "${BUILTIN_DATADIRS}${PATH_DELIM_T}${CMAKE_INSTALL_PREFIX}${PATH_SEP_T}${AI_DATA_DIR}")
endif (NOT "${AI_DATA_DIR}" STREQUAL "${DATADIR}" AND NOT "${AI_DATA_DIR}" STREQUAL "${AI_LIBS_DIR}")
add_definitions(-DSPRING_DATADIR="${BUILTIN_DATADIRS}")



# Spring Related USE-Flags
set(LOG_LEVEL "DEFAULT" CACHE STRING
		"The minimum log level.
		Log messages below this level
		will not be compiled into the binary.
		Available levels:
		* DEFAULT (DEBUG on debug builds, INFO on release builds)
		* DEBUG (log everything)
		* INFO
		* WARNING (only use this if you know what you are doing!)")
if    (NOT "${LOG_LEVEL}" STREQUAL "DEFAULT")
	add_definitions(-D_LOG_LEVEL_MIN=LOG_LEVEL_${LOG_LEVEL})
endif (NOT "${LOG_LEVEL}" STREQUAL "DEFAULT")

option(SYNCCHECK "Check sync during gameplay (Required for online play!)" TRUE)
if    (SYNCCHECK)
	add_definitions(-DSYNCCHECK)
endif (SYNCCHECK)

option(NO_CREG "Disable creg support" FALSE)
if    (NO_CREG)
	add_definitions(-DNOT_USING_CREG)
endif (NO_CREG)

option(NO_SOUND "No sound output support" FALSE)

if    (WIN32)
	## internal AVI recorder (w/o sound atm)
	option(NO_AVI "Disable in-game video recording" FALSE)
	if    (NOT NO_AVI)
		add_definitions(-DAVI_CAPTURING)
	endif (NOT NO_AVI)

	if   (NOT MSVC)
		## stdout console
		option(WINDOWS_CONSOLE "Show a visible cmd.exe with stdout when spring runs" FALSE)
		if    (NOT WINDOWS_CONSOLE)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mwindows")
		endif (NOT WINDOWS_CONSOLE)
	endif(NOT MSVC)
endif (WIN32)

option(USE_LIBSQUISH "Enable libsquish for DXT decompressing. (needed for ETC1 support)" TRUE)
if    (USE_LIBSQUISH)
	add_definitions(-DUSE_LIBSQUISH)
endif (USE_LIBSQUISH)



FIND_PACKAGE(Boost 1.51.0 COMPONENTS regex system REQUIRED)
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})

# Note the missing REQUIRED, as headless & dedi may not depend on those.
#  So req. checks are done in the build target's CMakeLists.txt.
FIND_PACKAGE(SDL2)

FIND_PACKAGE_STATIC(DevIL)
IF    (PREFER_STATIC_LIBS)
	# dependencies of DevIL
	FIND_PACKAGE_STATIC(JPEG REQUIRED)
	FIND_PACKAGE_STATIC(PNG REQUIRED)
	FIND_PACKAGE_STATIC(TIFF REQUIRED)
	FIND_PACKAGE_STATIC(GIF REQUIRED)
ENDIF (PREFER_STATIC_LIBS)

if    (WIN32)
	FIND_PACKAGE(Windres)
	SET(CMAKE_RC_COMPILER ${WINDRES_BIN})
	FIND_PACKAGE(Win32Libs REQUIRED)
endif (WIN32)

if     (WIN32)
	set(CMAKE_SHARED_LIBRARY_PREFIX "")
	set(CMAKE_SHARED_MODULE_PREFIX "")
elseif (UNIX)
	# unix specifics
else   (UNIX)
	# mac
	FIND_LIBRARY(COREFOUNDATION_LIBRARY CoreFoundation)
	INCLUDE_DIRECTORIES("${COREFOUNDATION_LIBRARY}/Headers")
endif  (WIN32)

FIND_PACKAGE(Valgrind)
if    (VALGRIND_FOUND)
	add_definitions(-DUSE_VALGRIND)
endif (VALGRIND_FOUND)

INCLUDE (CheckSymbolExists)
CHECK_SYMBOL_EXISTS(strnlen string.h HAVE_STRNLEN)
if (NOT HAVE_STRNLEN)
	Message(FATAL_ERROR "this compiler/environment isn't supported, the function strnlen is missing!")
endif()

### Add Link-Time-Optimization flags, if supported (GCC >= 4.5) and enabled
option(LTO "Link Time Optimizations (LTO)" FALSE)
if    (LTO)
	if    (NOT LTO_FLAGS)
		Message(WARNING "Tried to enable LTO, but compiler doesn't support it!")
	endif (NOT LTO_FLAGS)
	Set(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS}           ${LTO_FLAGS}")
	Set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS}    ${LTO_FLAGS}")
	Set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${LTO_FLAGS}")
endif (LTO)


### Memory Access Protection (BoundsChecking)
option(DEBUG_BOUNDSCHECK "Array/Pointer BoundsChecking a.k.a. buffer overflow protection (debug)" FALSE)
if    (DEBUG_BOUNDSCHECK)
	if    (NOT MPX_FLAGS)
		Message(WARNING "Tried to enable BoundsCheck, but compiler doesn't support it!")
	endif (NOT MPX_FLAGS)
	Set(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS}           ${MPX_FLAGS}")
	Set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS}    ${MPX_FLAGS}")
	Set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${MPX_FLAGS}")
endif (DEBUG_BOUNDSCHECK)


### ld.gold
option(COMPRESS_DEBUG_SYMBOLS "Compresses the DebugSymbols (needs ld.gold, beware: slow)" FALSE)
if    (LDGOLD_FOUND)
	Message(STATUS "Found ld.gold")
	if    (COMPRESS_DEBUG_SYMBOLS)

=== AI/CMakeLists.txt ===
### AI
#
# Global variables set in this file:
# * AI_EXCLUDE_REGEX
# * AI_FIND_QUIETLY
# * DEPS_AI_ALL
#
# Functions and macros defined in this file:
# * AIMessage
#

add_definitions(-DBUILDING_AI)


### User-definable build options
set (AI_EXCLUDE_REGEX "XXXXXXXX" CACHE STRING "Which Skirmish AIs not to build (none by default, example: \"NTai|Null.*AI\", see also: AI_TYPES")
option(AI_FIND_QUIETLY  "Whether to find AI Interfaces and Skirmish AIs quietly" FALSE)

set(rts             "${CMAKE_SOURCE_DIR}/rts")

include_directories(
	${rts}
	${CMAKE_BINARY_DIR}/src-generated/engine
	${rts}/ExternalAI/Interface
	Wrappers
	)

# Set these for Interfaces and AIs with C sources
set(CMAKE_C_FLAGS_DEBUG          "${CMAKE_CXX_FLAGS_DEBUG}")
set(CMAKE_C_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE}")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
set(CMAKE_C_FLAGS_PROFILE        "${CMAKE_CXX_FLAGS_PROFILE}")

remove_definitions(-DSTREFLOP_SSE)
add_definitions(${PIC_FLAG} -D_REENTRANT -D_GNU_SOURCE=1)

if    (MINGW)
	set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--kill-at -Wl,--add-stdcall-alias")
endif (MINGW)


# Assemble common additional native AI sources
#list(APPEND ai_common_SRC "${rts}/Game/GameVersion.cpp")
list(APPEND ai_common_SRC "${rts}/System/SafeCStrings.c")


# Set some Skirmish AI stuff here already,
# cause it is used by NullPythonAI in Interfaces/Python

# Export Paths needed for the AIs
set(SKIRMISH_AI_LIBS        "${AI_LIBS_DIR}/AI/Skirmish")
set(SKIRMISH_AI_DATA        "${AI_DATA_DIR}/AI/Skirmish")

# Display messages on configure, which AIs are found
set(SKIRMISHAI_FIND_QUIETLY ${AI_FIND_QUIETLY})

MakeGlobal(SKIRMISH_AI_LIBS SKIRMISH_AI_DATA SKIRMISHAI_FIND_QUIETLY)


# Print a message, but only if we are allowed to speak.
macro    (AIMessage type msg)
	if    (NOT AI_FIND_QUIETLY)
		message(${type} "${msg}")
	endif (NOT AI_FIND_QUIETLY)
endmacro (AIMessage type msg)


find_package(AWK)

# CUtils has to come first, because the Interfaces use it too
Add_Subdirectory(Wrappers/CUtils)
Add_Subdirectory(Interfaces)
Add_Subdirectory(Wrappers)
Add_Subdirectory(Skirmish)

set(DEPS_AI_ALL
		${DEPS_AI_INTERFACES}
		${DEPS_AI_WRAPPERS}
		${DEPS_AI_SKIRMISH}
	)
MakeGlobal(DEPS_AI_ALL)

=== cont/CMakeLists.txt ===
# required for man pages (optional) and base files (mandatory)

### Make base-files (aka sdz's)
add_subdirectory(base)

### Install base-files
install (DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/ DESTINATION ${DATADIR}
		PATTERN ".gitignore" EXCLUDE
		PATTERN "base" EXCLUDE
		PATTERN "freedesktop" EXCLUDE
		PATTERN "CMakeLists.txt" EXCLUDE
		PATTERN "CMakeCache" EXCLUDE
		PATTERN "CMakeFiles" EXCLUDE
		PATTERN "Makefile" EXCLUDE
		PATTERN "cmake_install.cmake" EXCLUDE
		PATTERN "springrc-template-insource.txt" EXCLUDE
	)

### Install freedesktop-files, mime-types etc.
if    (UNIX)
	install (
		FILES
			${CMAKE_CURRENT_SOURCE_DIR}/freedesktop/applications/spring.desktop
		DESTINATION
			${APPLICATIONS_DIR}
		)
	install (
		FILES
			${CMAKE_CURRENT_SOURCE_DIR}/freedesktop/mime/spring.xml
		DESTINATION
			${MIME_DIR}/packages
		)
	install (
		FILES
			${CMAKE_CURRENT_SOURCE_DIR}/freedesktop/pixmaps/spring.png
			${CMAKE_CURRENT_SOURCE_DIR}/freedesktop/pixmaps/application-x-spring-demo.png
		DESTINATION
			${PIXMAPS_DIR}
		)
endif (UNIX)

if (NOT EXISTS ${Spring_BINARY_DIR}/springsettings.cfg)
	if(WIN32)
		set(PLACEHOLDER ";")
	else()
		set(PLACEHOLDER ":")
	endif()
	set("SpringDataDirInSource" "${Spring_BINARY_DIR}${PLACEHOLDER}${Spring_SOURCE_DIR}/cont")
	configure_file(springrc-template-insource.txt ${Spring_BINARY_DIR}/springsettings.cfg)
else()
	message(STATUS "${Spring_BINARY_DIR}/springsettings.cfg already exists!")
endif()

### Install dependencies (windows, mingwlibs DLLs)
if    (MINGW)
	install (DIRECTORY ${MINGWLIBS}/dll/ DESTINATION ${BINDIR} PATTERN "*.dll")

	#execute_process(COMMAND ${CMAKE_CXX_COMPILER} "-print-file-name=libstdc++-6.dll" OUTPUT_VARIABLE STDCXX_LIBRARY OUTPUT_STRIP_TRAILING_WHITESPACE)
	#install(FILES ${STDCXX_LIBRARY} DESTINATION ${BINDIR})

	# pthreadGC2 is a dependency of ThreadPool
#	find_library(PTHREADGC2_LIBRARY NAMES pthreadGC2)
#	if(NOT EXISTS ${PTHREADGC2_LIBRARY})
#		message(SEND_ERROR "pthreadGC2 not found!")
#	endif()
#	install(FILES ${PTHREADGC2_LIBRARY} DESTINATION ${BINDIR})
endif (MINGW)

=== doc/CMakeLists.txt ===

### make and install the man pages
if    (UNIX)
	FIND_PACKAGE(SevenZip)
	set(AsciiDoc_FIND_QUIETLY TRUE)
	FIND_PACKAGE(AsciiDoc)
	set(CREATE_MAN_PAGES)
	if    (SEVENZIP_FOUND AND ASCIIDOC_FOUND AND XSLTPROC_FOUND AND DOCBOOK_FOUND)
		execute_process(
			COMMAND "${ASCIIDOC_BIN}"
			RESULT_VARIABLE ASCIIDOC_RESULT
			ERROR_QUIET
			OUTPUT_QUIET
			ERROR_STRIP_TRAILING_WHITESPACE)
		if    (ASCIIDOC_RESULT EQUAL 0)
			MakeGlobalVar(CREATE_MAN_PAGES TRUE)
		else  (ASCIIDOC_RESULT EQUAL 0)
			MakeGlobalVar(CREATE_MAN_PAGES FALSE)
			message(STATUS "MAN pages will not be generated/installed (utility asciidoc is broken)")
		endif (ASCIIDOC_RESULT EQUAL 0)
	else  (SEVENZIP_FOUND AND ASCIIDOC_FOUND AND XSLTPROC_FOUND AND DOCBOOK_FOUND)
		set(MISSING_UTILS "")
		if    (NOT SEVENZIP_FOUND)
			set(MISSING_UTILS "${MISSING_UTILS} 7z*")
		endif (NOT SEVENZIP_FOUND)
		if    (NOT ASCIIDOC_FOUND)
			set(MISSING_UTILS "${MISSING_UTILS} asciidoc")
		endif (NOT ASCIIDOC_FOUND)
		if    (NOT XSLTPROC_FOUND)
			set(MISSING_UTILS "${MISSING_UTILS} xsltproc")
		endif (NOT XSLTPROC_FOUND)
		if    (NOT DOCBOOK_FOUND)
			set(MISSING_UTILS "${MISSING_UTILS} docbook-xsl")
		endif (NOT DOCBOOK_FOUND)
		message(STATUS "MAN pages will not be generated/installed; missing utilit(y|ies):${MISSING_UTILS}")
	endif (SEVENZIP_FOUND AND ASCIIDOC_FOUND AND XSLTPROC_FOUND AND DOCBOOK_FOUND)

	if    (CREATE_MAN_PAGES)
		set(MAN_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/manpages")
		set(MAN_BUILD_DIR  "${CMAKE_BINARY_DIR}/manpages")
		set(MAN_DEST_DIR   "${MANDIR}/man6")

		Set(man_src
				"${MAN_SOURCE_DIR}/spring.6.txt")
		Set(man_dst
				"${MAN_BUILD_DIR}/spring-dedicated.6.gz"
				"${MAN_BUILD_DIR}/spring-headless.6.gz"
				"${MAN_BUILD_DIR}/spring-legacy.6.gz"
				"${MAN_BUILD_DIR}/spring.6.gz")
		set_source_files_properties(${man_dst} PROPERTIES GENERATED TRUE)

		Add_Custom_Command(
			OUTPUT ${man_dst}
			COMMAND "${MAN_SOURCE_DIR}/make_manpages.sh"
				"${MAN_BUILD_DIR}"
				"${ASCIIDOC_BIN}"
				"${XSLTPROC_BIN}"
				"${DOCBOOK_XSL}"
				"${SEVENZIP_BIN}"
			DEPENDS ${man_src}
			WORKING_DIRECTORY "${MAN_SOURCE_DIR}"
			COMMENT "manpages: Generating" VERBATIM
		)

		add_custom_target(manpages ALL DEPENDS ${man_dst})

		install(FILES ${man_dst} DESTINATION "${MAN_DEST_DIR}")

		message(STATUS "MAN pages will be installed to {INSTALL_PREFIX}/${MAN_DEST_DIR}")
	endif (CREATE_MAN_PAGES)
endif (UNIX)

option(USERDOCS_PLAIN "Install plain/text engine user-docs (README, LICENSE, etc.)" FALSE)
option(USERDOCS_HTML "Install HTML engine user-docs (README.html, LICENSE.html, etc.)" FALSE)

### make and install the user-doc pages (README, LICENSE, ...)
If     (WIN32)
	Set(DOC_DEST_DIR "${DOCDIR}")
Else   (WIN32)
	Set(DOC_DEST_DIR "${DOCDIR}/engine")
EndIf  (WIN32)

Set(userdoc_INSTALL_HTML FALSE)
If     (USERDOCS_HTML)
	set(Pandoc_FIND_QUIETLY TRUE)
	FIND_PACKAGE(Pandoc)
	If     (NOT PANDOC_FOUND)
		Set(Markdown_FIND_QUIETLY TRUE)
		Find_Package(Markdown)
	EndIf  (NOT PANDOC_FOUND)

	If     (PANDOC_FOUND OR MARKDOWN_FOUND)
		Set(userdoc_INSTALL_HTML TRUE)

		# Generates "${name}.html" from "${name}(.markdown)"
		Macro    (Userdoc_GenerateHtml name var_srcFile)
			Set(DST_FILE_${name} "${CMAKE_CURRENT_BINARY_DIR}/${name}.html")

			If     (PANDOC_FOUND)
				Pandoc_MdToHtml(  convert_command_${name}
						"${${var_srcFile}}" "${DST_FILE_${name}}"
						"Spring RTS Game Engine - ${name}")
			Else   ()
				Markdown_MdToHtml(convert_command_${name}
						"${${var_srcFile}}" "${DST_FILE_${name}}")
			EndIf  ()
			add_custom_command(
				OUTPUT "${DST_FILE_${name}}"
				COMMAND ${convert_command_${name}}
				DEPENDS "${${var_srcFile}}"
				COMMENT "Creating userdoc ${name}.html" VERBATIM
			)

			List(APPEND userdoc_html_generated "${DST_FILE_${name}}")

			set_source_files_properties("${DST_FILE_${name}}" PROPERTIES GENERATED TRUE)
		EndMacro (Userdoc_GenerateHtml)
	Else   (PANDOC_FOUND OR MARKDOWN_FOUND)
		Message(WARNING "user-docs generation (html/text) is not possible (disable with USERDOCS_HTML=FALSE); missing utility: pandoc or markdown")
	EndIf  (PANDOC_FOUND OR MARKDOWN_FOUND)

	Set(userdoc_html_generated "")
EndIf  (USERDOCS_HTML)

If     (USERDOCS_PLAIN OR userdoc_INSTALL_HTML)
	Set(userdoc_plain "")

	Macro    (Userdoc_Enlist name)
		Set(userdoc_file_plain_${name} "${CMAKE_SOURCE_DIR}/${name}.markdown")
		If     (NOT EXISTS "${userdoc_file_plain_${name}}")
			Set(userdoc_file_plain_${name} "${CMAKE_SOURCE_DIR}/${name}")
		EndIf  ()

		List(APPEND userdoc_plain "${userdoc_file_plain_${name}}")

		If     (userdoc_INSTALL_HTML)
			Userdoc_GenerateHtml("${name}" userdoc_file_plain_${name})
		EndIf  (userdoc_INSTALL_HTML)
	EndMacro (Userdoc_Enlist)

	Userdoc_Enlist("AUTHORS")
	Userdoc_Enlist("README")
	Userdoc_Enlist("COPYING")
	Userdoc_Enlist("FAQ")
	Userdoc_Enlist("LICENSE")
	Userdoc_Enlist("THANKS")
EndIf  (USERDOCS_PLAIN OR userdoc_INSTALL_HTML)

Set(userdoc_INSTALL_PLAIN ${USERDOCS_PLAIN})
If     (userdoc_INSTALL_PLAIN)
	Set(userdoc_plain
			"${userdoc_plain}"
			"${CMAKE_SOURCE_DIR}/gpl-2.0.txt"
			"${CMAKE_SOURCE_DIR}/gpl-3.0.txt")

	Install(FILES ${userdoc_plain} DESTINATION "${DOC_DEST_DIR}")

	Message(STATUS "user-docs (plain/text) will be installed to {INSTALL_PREFIX}/${DOC_DEST_DIR}")
EndIf  (userdoc_INSTALL_PLAIN)

If     (userdoc_INSTALL_HTML)
	add_custom_target(userdocs ALL DEPENDS ${userdoc_html_generated})
	Add_Dependencies(generateSources userdocs)

	Set(userdoc_html
			"${userdoc_html_generated}"
			"${CMAKE_SOURCE_DIR}/gpl-2.0.html"
			"${CMAKE_SOURCE_DIR}/gpl-3.0.html")

	Install(FILES ${userdoc_html} DESTINATION "${DOC_DEST_DIR}")

	Message(STATUS "user-docs (html/text) will be installed to {INSTALL_PREFIX}/${DOC_DEST_DIR}")
EndIf  (userdoc_INSTALL_HTML)

=== rts/CMakeLists.txt ===
# Place executables and shared libs under "build-dir/",
# instead of under "build-dir/rts/"
# This way, we have the build-dir structure more like the install-dir one,
# which makes testing spring in the builddir easier, eg. like this:
# cd build-dir
# SPRING_DATADIR=$(pwd) ./spring
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")

SET(ENGINE_SRC_ROOT_DIR "${CMAKE_SOURCE_DIR}/rts")


option(TRACE_SYNC "Enable sync tracker" FALSE)
if (TRACE_SYNC)
	ADD_DEFINITIONS(-DTRACE_SYNC)
endif (TRACE_SYNC)

option(SYNCDEBUG "Enable sync debugger (needs SYNCCHECK=true)" FALSE)
if (SYNCDEBUG)
	ADD_DEFINITIONS(-DSYNCDEBUG)
	If     (NOT "${CMAKE_BUILD_TYPE}" STREQUAL "DEBUG")
		Message(WARNING "It is recommended to set CMAKE_BUILD_TYPE to DEBUG for a SYNCDEBUG build")
	EndIf  ()
	If     (NOT SYNCCHECK)
		Message(FATAL_ERROR "You need SYNCCHECK=TRUE for a SYNCDEBUG build")
	EndIf  ()
	If     (NOT TRACE_SYNC)
		Message(WARNING "It is recommended to use TRACE_SYNC=TRUE for a SYNCDEBUG build")
	EndIf  ()
endif (SYNCDEBUG)

option(DEBUG_GLSTATE "enable GL_STATE_CHECKER" FALSE)
if(DEBUG_GLSTATE)
	add_definitions(-DDEBUG_GLSTATE)
endif()

### give error when not found
FIND_PACKAGE_STATIC(DevIL REQUIRED)

### Assemble common incude dirs
INCLUDE_DIRECTORIES(BEFORE lib/lua/include)
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include/AL)
INCLUDE_DIRECTORIES(${SPRING_MINIZIP_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(${IL_INCLUDE_DIR})

### Assemble common libraries
Add_Subdirectory(System/Sound)
if    (NO_SOUND)
	ADD_DEFINITIONS(-DNO_SOUND)
endif (NO_SOUND)

### Find include directories and add platform specific libraries
IF    (UNIX AND NOT MINGW)
	IF    (PREFER_STATIC_LIBS)
		PREFER_STATIC_LIBS()
		FIND_LIBRARY(C_LIBRARY c)
		FIND_LIBRARY(MATH_LIBRARY m)
		#FIND_LIBRARY(PTHREAD_LIBRARY pthread)
		#FIND_LIBRARY(OMP_LIBRARY gomp) FIXME it's hidden in some subfolders
		UNPREFER_STATIC_LIBS()

		LIST(APPEND engineCommonLibraries ${C_LIBRARY} ${MATH_LIBRARY})
		#LIST(APPEND engineCommonLibraries ${PTHREAD_LIBRARY} ${OMP_LIBRARY})
	ENDIF (PREFER_STATIC_LIBS)

	# Needed for dynamically loading shared libraries (on some OS)
	LIST(APPEND engineCommonLibraries ${CMAKE_DL_LIBS})

	# Needed for backtrace* on some systems
	IF(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
		LIST(APPEND engineCommonLibraries execinfo)
	ENDIF(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
ENDIF (UNIX AND NOT MINGW)

FIND_PACKAGE_STATIC(ZLIB REQUIRED)
LIST(APPEND engineCommonLibraries ${IL_LIBRARIES} ${JPEG_LIBRARY} ${PNG_LIBRARY} ${TIFF_LIBRARY} ${GIF_LIBRARY})
LIST(APPEND engineCommonLibraries ${Boost_REGEX_LIBRARY})
LIST(APPEND engineCommonLibraries ${Boost_SYSTEM_LIBRARY})
LIST(APPEND engineCommonLibraries 7zip ${SPRING_MINIZIP_LIBRARY} ${ZLIB_LIBRARY})
LIST(APPEND engineCommonLibraries lua luasocket archives assimp gflags)
if (ENABLE_STREFLOP)
LIST(APPEND engineCommonLibraries streflop)
endif ()

include_directories(${ZLIB_INCLUDE_DIR})

IF (WIN32)
	LIST(APPEND engineCommonLibraries ${WIN32_LIBRARIES})
ENDIF (WIN32)

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
	#tcmalloc on freebsd is broken, default disable it (#4754)
	set(USE_TCMALLOC_DEFAULT FALSE)
else()
	set(USE_TCMALLOC_DEFAULT TRUE)
endif()

FIND_PACKAGE_STATIC(TCMalloc)
option(USE_TCMALLOC "use tcmalloc (part of google's perftools)" ${USE_TCMALLOC_DEFAULT})
if    (USE_TCMALLOC AND TCMALLOC_LIBRARY)
	MESSAGE(STATUS "Using tcmalloc")
	LIST(APPEND engineCommonLibraries ${TCMALLOC_LIBRARY})
endif (USE_TCMALLOC AND TCMALLOC_LIBRARY)


if(UNIX)
	FIND_PACKAGE_STATIC(Libunwind REQUIRED)
	LIST(APPEND engineCommonLibraries ${LIBUNWIND_LIBRARIES})
	if(LIBUNWIND_FOUND)
		message(STATUS "Found libunwind libraries at ${LIBUNWIND_LIBRARIES}")
	else()
		message(FATAL_ERROR "Couldn't find libunwind")
	endif()
endif()



### Assemble engine sources
Add_Subdirectory(Game)
Add_Subdirectory(Lua)
Add_Subdirectory(ExternalAI)
Add_Subdirectory(Rendering)
Add_Subdirectory(aGui)
Add_Subdirectory(Menu)
Add_Subdirectory(Map)
Add_Subdirectory(Net)
Add_Subdirectory(Sim)
#Add_Subdirectory(System) # this is already added in ../

MakeGlobalVar(engineSources
		${sources_engine_Game}
		${sources_engine_Net}
		${sources_engine_Lua}
		${sources_engine_Map}
		${sources_engine_Rendering}
		${sources_engine_Menu}
		${sources_engine_System}
		${sources_engine_ExternalAI}
	)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/lib/assimp/include) #FIXME: hack for rts/Rendering/Models/IModelParser.cpp

### Add headers for generated project files (e.g. Code::Blocks)
file(GLOB_RECURSE engineHeaders "*.h" "*.hpp" "*.inl")


Add_Subdirectory(builds)

=== test/CMakeLists.txt ===
# See README.md for usage instructions
If (MINGW)
	RemoveFlag("-mwindows")
EndIf (MINGW)

FIND_PACKAGE(Boost 1.35.0 COMPONENTS unit_test_framework chrono thread system)

If    (NOT Boost_FOUND)
	Message(STATUS "Note: Unit tests will not be built: Boost::test library was not found")
Else  (NOT Boost_FOUND)
	# defines spring_test_compile_fail macro
	INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/tools/CompileFailTest/CompileFailTest.cmake)

	# boost::chrono depends on clock_gettime which we need to link ourself when boost is static linked
	Set(Boost_CHRONO_LIBRARY_WITH_RT ${Boost_CHRONO_LIBRARY})
	IF    (UNIX AND NOT MINGW)
		FIND_LIBRARY(REALTIME_LIBRARY rt)

		IF    (PREFER_STATIC_LIBS AND NOT EXISTS "${REALTIME_LIBRARY}")
			MESSAGE(FATAL_ERROR "librt.[so|a] not found! Needed by std/boost chrono when static linked!")
		ENDIF (PREFER_STATIC_LIBS AND NOT EXISTS "${REALTIME_LIBRARY}")

		# zydox buildslave seems to have problems to autolink it from dynlinked boost libs
		#  so always link it (won't hurt cause std/boost chrono need it never the less)
		if    (EXISTS "${REALTIME_LIBRARY}")
			LIST(APPEND Boost_CHRONO_LIBRARY_WITH_RT ${REALTIME_LIBRARY})
		ENDIF (EXISTS "${REALTIME_LIBRARY}")
	ENDIF (UNIX AND NOT MINGW)

	INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
	INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR}/src-generated/engine)

	SET(ENGINE_SOURCE_DIR "${CMAKE_SOURCE_DIR}/rts")
	INCLUDE_DIRECTORIES(${ENGINE_SOURCE_DIR})
	INCLUDE_DIRECTORIES(${ENGINE_SOURCE_DIR}/lib/asio/include)

	If	(NOT (WIN32 OR Boost_USE_STATIC_LIBS))
		#Win32 tests links static
		add_definitions(-DBOOST_TEST_DYN_LINK)
	EndIf	(NOT (WIN32 OR Boost_USE_STATIC_LIBS))
	add_definitions(-DSYNCCHECK -DUNIT_TEST)
	REMOVE_DEFINITIONS(-DTHREADPOOL)

	Set(test_Log_sources
			"${ENGINE_SOURCE_DIR}/System/SafeCStrings.c"
			"${ENGINE_SOURCE_DIR}/System/Log/Backend.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/LogUtil.c"
			"${ENGINE_SOURCE_DIR}/System/Log/DefaultFilter.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/DefaultFormatter.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/FramePrefixer.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/ConsoleSink.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/StreamSink.cpp"
		)

	Add_Custom_Target(tests)
	add_custom_target(check ${CMAKE_CTEST_COMMAND} --output-on-failure -V
		DEPENDS engine-headless)
	add_custom_target(install-tests)

	macro (add_spring_test target sources libraries flags)
		ADD_TEST(NAME test${target} COMMAND test_${target})
		add_dependencies(tests test_${target})
		add_dependencies(check test_${target})
		add_dependencies(install-tests test_${target})
		add_executable(test_${target} EXCLUDE_FROM_ALL ${sources})
		target_link_libraries(test_${target} ${libraries})
		set_target_properties(test_${target} PROPERTIES COMPILE_FLAGS "${flags}")
		#install(TARGETS test_${target} DESTINATION ${BINDIR})
	endmacro()

################################################################################
### UDPListener
# disabled for travis: https://springrts.com/mantis/view.php?id=5014
if(NOT DEFINED ENV{CI})
	set(test_name UDPListener)
	Set(test_src
		"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Net/TestUDPListener.cpp"
		"${ENGINE_SOURCE_DIR}/Game/GameVersion.cpp"
		"${ENGINE_SOURCE_DIR}/Net/Protocol/BaseNetProtocol.cpp"
		"${ENGINE_SOURCE_DIR}/System/CRC.cpp"
		"${ENGINE_SOURCE_DIR}/System/Misc/SpringTime.cpp"
		## HACK:
		##   the engineSystemNet lib is compiled *without* -DUNIT_TEST
		##   it includes UDPConnection which depends on ConfigHandler
		##   in normal builds, but fails to link when used as part of
		##   UT so we compile it again
		"${ENGINE_SOURCE_DIR}/System/Net/UDPConnection.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/NullGlobalConfig.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Nullerrorhandler.cpp"
		${sources_engine_System_Threading}
		${test_Log_sources}
	)

	set(test_libs
		engineSystemNet
		${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		${Boost_SYSTEM_LIBRARY}
		${Boost_THREAD_LIBRARY}
		${Boost_CHRONO_LIBRARY_WITH_RT}
		${WINMM_LIBRARY}
		${WS2_32_LIBRARY}
		7zip
	)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")
	Add_Dependencies(test_UDPListener generateVersionFiles)
endif()

################################################################################
### ILog
	set(test_name ILog)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Log/TestILog.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/FileSink.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/OutputDebugStringSink.cpp"
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")

################################################################################
### SyncedPrimitive
	set(test_name SyncedPrimitive)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Sync/TestSyncedPrimitive.cpp"
			"${ENGINE_SOURCE_DIR}/System/Sync/SyncChecker.cpp"
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")

################################################################################
### RectangleOptimizer
	set(test_name RectangleOptimizer)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Misc/RectangleOptimizer.cpp"
			"${ENGINE_SOURCE_DIR}/System/Misc/RectangleOptimizer.cpp"
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "-DNOT_USING_CREG")

################################################################################
### Float3
	set(test_name Float3)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/testFloat3.cpp"
			"${ENGINE_SOURCE_DIR}/System/float3.cpp"
			"${ENGINE_SOURCE_DIR}/System/float4.cpp"
			"${ENGINE_SOURCE_DIR}/System/Misc/SpringTime.cpp"
			"${ENGINE_SOURCE_DIR}/System/TimeProfiler.cpp"
			${sources_engine_System_Threading}
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
			${Boost_THREAD_LIBRARY}
			${Boost_CHRONO_LIBRARY_WITH_RT}
			${WINMM_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "-DNOT_USING_CREG -DNOT_USING_STREFLOP -DBUILDING_AI")

################################################################################
### Matrix44f
	set(test_name Matrix44f)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/testMatrix44f.cpp"
			"${ENGINE_SOURCE_DIR}/System/Matrix44f.cpp"
			"${ENGINE_SOURCE_DIR}/System/float3.cpp"
			"${ENGINE_SOURCE_DIR}/System/float4.cpp"
			"${ENGINE_SOURCE_DIR}/System/TimeProfiler.cpp"
			"${ENGINE_SOURCE_DIR}/System/Misc/SpringTime.cpp"
			${sources_engine_System_Threading}
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
			${Boost_THREAD_LIBRARY}
			${Boost_CHRONO_LIBRARY_WITH_RT}
			${WINMM_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "-DNOT_USING_CREG -DNOT_USING_STREFLOP -DBUILDING_AI")

################################################################################
### Matrix44fRotation
	set(test_name Matrix44fRotation)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/testRotationMatrix44f.cpp"
			"${ENGINE_SOURCE_DIR}/System/Matrix44f.cpp"
			"${ENGINE_SOURCE_DIR}/System/float3.cpp"
			"${ENGINE_SOURCE_DIR}/System/float4.cpp"
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
			${Boost_THREAD_LIBRARY}
			${Boost_CHRONO_LIBRARY_WITH_RT}
			${WINMM_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "-DNOT_USING_CREG -DNOT_USING_STREFLOP -DBUILDING_AI")

################################################################################
### SpringTime
	set(test_name SpringTime)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Misc/testSpringTime.cpp"
			"${ENGINE_SOURCE_DIR}/System/Misc/SpringTime.cpp"
			"${ENGINE_SOURCE_DIR}/System/TimeProfiler.cpp"
			${sources_engine_System_Threading}
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
			${Boost_CHRONO_LIBRARY_WITH_RT}
			${Boost_THREAD_LIBRARY}
			${WINMM_LIBRARY}
		)

	set(test_flags "-DNOT_USING_CREG -DNOT_USING_STREFLOP -DBUILDING_AI")
	if (Boost_TIMER_FOUND)
		LIST(APPEND test_libs ${Boost_TIMER_LIBRARY})
		set(test_flags "${test_flags} -DBoost_TIMER_FOUND")
	endif (Boost_TIMER_FOUND)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "${test_flags}")


################################################################################
### BitwiseEnum
	set(test_name BitwiseEnum)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Misc/TestBitwiseEnum.cpp"
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		)

	# positive tests (should compile fine)
	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")
	Add_Dependencies(tests test_BitwiseEnum)

	# negative tests (must not compile)
	spring_test_compile_fail(testBitwiseEnum_fail1 ${test_src} "-DTEST1")
	spring_test_compile_fail(testBitwiseEnum_fail2 ${test_src} "-DTEST2")
	spring_test_compile_fail(testBitwiseEnum_fail3 ${test_src} "-DTEST3")


################################################################################
### FileSystem
	set(test_name FileSystem)
	Set(test_src
			"${ENGINE_SOURCE_DIR}/System/FileSystem/FileSystem.cpp"
			"${ENGINE_SOURCE_DIR}/System/FileSystem/FileSystemAbstraction.cpp"
			"${ENGINE_SOURCE_DIR}/System/StringUtil.cpp"
			"${ENGINE_SOURCE_DIR}/Game/GameVersion.cpp"
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/FileSystem/TestFileSystem.cpp"
			${test_Log_sources}
		)
	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_FILESYSTEM_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
			${Boost_REGEX_LIBRARY}
		)
	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")
	add_dependencies(test_${test_name} generateVersionFiles)
################################################################################
### LuaSocketRestrictions
	set(test_name LuaSocketRestrictions)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/lib/luasocket/TestRestriction.cpp"
			"${ENGINE_SOURCE_DIR}/lib/luasocket/src/restrictions.cpp"
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_REGEX_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "-DTEST")

	if    (NOT NO_CREG)
################################################################################
### CREG
		add_test(NAME testCreg COMMAND ${CMAKE_BINARY_DIR}/spring-headless${CMAKE_EXECUTABLE_SUFFIX} --test-creg)

### CREG LoadSave
		set(test_name LoadSave)
		Set(test_src
				"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/LoadSave/testCregLoadSave.cpp"
				"${ENGINE_SOURCE_DIR}/System/creg/Serializer.cpp"
				"${ENGINE_SOURCE_DIR}/System/creg/VarTypes.cpp"
				"${ENGINE_SOURCE_DIR}/System/creg/creg.cpp"
				${test_Log_sources}
			)

		set(test_libs
				${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
				${Boost_REGEX_LIBRARY}
			)

		add_spring_test(${test_name} "${test_src}" "${test_libs}" -"DTEST")
###
################################################################################
	endif (NOT NO_CREG)

################################################################################
### UnitSync
	set(test_name UnitSync)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/unitsync/testUnitSync.cpp"
			"${ENGINE_SOURCE_DIR}/Lua/LuaMemPool.cpp"
			"${ENGINE_SOURCE_DIR}/System/Misc/SpringTime.cpp"
			${sources_engine_System_Threading}
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${CMAKE_DL_LIBS}
			unitsync
		)

	set(test_flags "-DUNITSYNC")
	add_spring_test(${test_name} "${test_src}" "${test_libs}" "${test_flags}")
	add_dependencies(test_${test_name} springcontent.sdz)

################################################################################
### ThreadPool
	set(test_name ThreadPool)
	Set(test_src

=== tools/CMakeLists.txt ===

Add_Subdirectory(unitsync)
Add_Subdirectory(DemoTool)

If    (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/pr-downloader/CMakeLists.txt")
	MESSAGE(FATAL_ERROR "${CMAKE_CURRENT_SOURCE_DIR}/pr-downloader/ is missing, please run\n git submodule init && git submodule update")
EndIf ()

# only add this if the submodule is present
find_package(CURL REQUIRED)
set(CMAKE_BUILD_TYPE "RELEASE")
set(CLEAR_COMPILER_FLAGS true)
set(PRD_BINDIR ${BINDIR} CACHE PATH "" FORCE)
set(PRD_LIBDIR ${LIBDIR} CACHE PATH "" FORCE)
Add_Subdirectory(pr-downloader)
# add install-pr-downloader target
Set(myInstallDeps pr-downloader)
Set(myInstallDirs "tools/pr-downloader")
CreateInstallTarget("pr-downloader" myInstallDeps myInstallDirs)

# This is not part of the official source package
if    (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/dirchange)
	Add_Subdirectory(dirchange)
endif (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/dirchange)

=== AI/Interfaces/CMakeLists.txt ===
### AI Interfaces
#
# Functions and macros defined in this file:
# * AIInterfaceMessage
#

add_definitions(-DBUILDING_AI_INTERFACE)

set(AI_INTERFACES_SRC        "${CMAKE_CURRENT_SOURCE_DIR}")
set(AI_INTERFACES_LIBS       "${AI_LIBS_DIR}/AI/Interfaces")
set(AI_INTERFACES_DATA       "${AI_DATA_DIR}/AI/Interfaces")
set(AIINTERFACE_FIND_QUIETLY ${AI_FIND_QUIETLY})


# Print a message, but only if we are allowed to speak.
macro    (AIInterfaceMessage type msg)
	if    (NOT AIINTERFACE_FIND_QUIETLY)
		message(${type} "${msg}")
	endif (NOT AIINTERFACE_FIND_QUIETLY)
endmacro (AIInterfaceMessage type msg)


# Add all AI Interface submodules
GetListOfSubModules(AI_INTERFACE_DIRS)
set(DEPS_AI_INTERFACES "")
foreach    (aiInterfaceDir ${AI_INTERFACE_DIRS})
	if     (NOT "${aiInterfaceDir}" STREQUAL "Python")
	Add_Subdirectory(${aiInterfaceDir})
	list(APPEND DEPS_AI_INTERFACES ${aiInterfaceDir}-AIInterface)
	elseif (NOT "${aiInterfaceDir}" STREQUAL "Python")
		AIInterfaceMessage(STATUS "Python AI Interface is not yet compatible with pureint changes -> temporarily disabled")
	endif  (NOT "${aiInterfaceDir}" STREQUAL "Python")
endforeach (aiInterfaceDir)
MakeGlobal(DEPS_AI_INTERFACES)

=== rts/ExternalAI/CMakeLists.txt ===

# This list was created using this *nix shell command:
# > find . -name "*.cpp"" | sort
SET(sources_engine_ExternalAI
		"${CMAKE_CURRENT_SOURCE_DIR}/AICallback.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AICheats.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AIInterfaceKey.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AIInterfaceLibrary.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AIInterfaceLibraryInfo.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AILibraryManager.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AISCommands.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/EngineOutHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/IAILibraryManager.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaAIImplHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SAIInterfaceCallbackImpl.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SSkirmishAICallbackImpl.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAIData.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAIHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAIKey.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAILibrary.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAILibraryInfo.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAIWrapper.cpp"
		PARENT_SCOPE
	)

=== rts/Game/CMakeLists.txt ===

# This list was created using this *nix shell command:
# > find . -name "*.cpp" | sort
MakeGlobalVar(sources_engine_Game
		"${CMAKE_CURRENT_SOURCE_DIR}/Action.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AviVideoCapturing.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Benchmark.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/CameraController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/FPSController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/FreeController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/OverheadController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/OverviewController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/RotOverheadController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/SpringController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/CameraHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ChatMessage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ClientData.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ClientSetup.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/CommandMessage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Console.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ConsoleHistory.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/DummyVideoCapturing.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/FPSUnitController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Game.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameData.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameHelper.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameSetup.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameVersion.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GlobalUnsynced.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/IVideoCapturing.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/InMapDraw.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/InMapDrawModel.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LoadScreen.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Players/Player.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Players/PlayerBase.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Players/PlayerHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Players/PlayerStatistics.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Players/TeamController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/PreGame.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SelectedUnitsHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SelectedUnitsAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SyncedGameCommands.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/TraceRay.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/CommandColors.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/CursorIcons.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/EndGameBox.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/GameInfo.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/GameSetupDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/GuiHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/Groups/Group.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/Groups/GroupHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/HwMouseCursor.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/InfoConsole.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/InputReceiver.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/KeyBindings.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/KeyCodes.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/KeySet.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/MiniMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/MouseCursor.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/MouseHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/PlayerRoster.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/PlayerRosterDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/ProfileDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/QuitBox.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/ResourceBar.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/SelectionKeyHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/ShareBox.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/StartPosSelecter.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/TooltipConsole.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/UnitTracker.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UnsyncedGameCommands.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/WaitCommandsAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/WordCompletion.cpp"
	)

=== rts/Lua/CMakeLists.txt ===

# This list was created using this *nix shell command:
# > find . -name "*.cpp"" | sort
SET(sources_engine_Lua
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaArchive.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaBitOps.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstCMD.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstCMDTYPE.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstCOB.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstGL.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstEngine.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstGame.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaConstPlatform.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaVFSDownload.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaFBOs.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaFeatureDefs.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaFonts.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaGaia.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaHandle.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaHandleSynced.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaIO.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaInputReceiver.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaInterCall.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaIntro.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaMaterial.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaMathExtra.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaMemPool.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaMenu.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaMetalMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaObjectRendering.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaOpenGL.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaOpenGLUtils.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaParser.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaPathFinder.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaRBOs.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaRules.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaRulesParams.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaScream.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaShaders.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaSyncedCtrl.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaSyncedMoveCtrl.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaSyncedRead.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaSyncedTable.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaTextures.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUICommand.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUnitDefs.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUnsyncedCtrl.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUnsyncedRead.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaUtils.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaVFS.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaWeaponDefs.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaZip.cpp"
		PARENT_SCOPE
	)

=== rts/Map/CMakeLists.txt ===

# This list was created using this *nix shell command:
# > find . -name "*.cpp"" | sort
SET(sources_engine_Map
		"${CMAKE_CURRENT_SOURCE_DIR}/BaseGroundDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/BasicMapDamage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Ground.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/HeightLinePalette.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/HeightMapTexture.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MapDamage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MapInfo.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MapParser.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MetalMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/NoMapDamage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ReadMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Generation/MapGenerator.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Generation/SimpleMapGenerator.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/Frustum.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/Plane.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/SM3GroundDrawer.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/SM3Map.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/Lightcalc.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/QuadRenderData.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/Terrain.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/TerrainTexEnvCombine.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/TerrainTexture.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/TerrainTextureGLSL.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/TerrainUtil.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/TerrainVertexBuffer.cpp"
#		"${CMAKE_CURRENT_SOURCE_DIR}/SM3/terrain/Textures.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/SMFGroundDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/SMFGroundTextures.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/SMFMapFile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/SMFReadMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/SMFRenderState.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/Basic/BasicMeshDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/Legacy/LegacyMeshDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/ROAM/Patch.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SMF/ROAM/RoamMeshDrawer.cpp"
		PARENT_SCOPE
	)

=== debian/changelog ===
spring (104.0+dfsg-8) unstable; urgency=medium

  * Team upload
  * debian/patches/libjsoncpp.patch:
    Fix build with newer jsoncpp (Closes: #976452)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 07 Dec 2020 18:21:59 +0100

spring (104.0+dfsg-7) unstable; urgency=medium

  * Switch to debhelper-compat = 13.
  * Fix build failure with gcc 10 due to missing include.
    Thanks to Steve Langasek for the patch. (Closes: #966885)

 -- Markus Koschany <apo@debian.org>  Wed, 05 Aug 2020 14:05:12 +0200

spring (104.0+dfsg-6) unstable; urgency=medium

  * Add bug-954722.patch and fix FTBFS due to error: conflicting declaration
    of ‘__pid_t gettid()’ with ‘C’ linkage. (Closes: #954722)

 -- Markus Koschany <apo@debian.org>  Sun, 05 Apr 2020 23:57:26 +0200

spring (104.0+dfsg-5) unstable; urgency=medium

  * Add use-sdl2-config.cmake.patch and workaround bug 951087.
    Fix FTBFS with latest SDL2 version. (Closes: #951974)
  * Declare compliance with Debian Policy 4.5.0.

 -- Markus Koschany <apo@debian.org>  Fri, 28 Feb 2020 01:11:27 +0100

spring (104.0+dfsg-4) unstable; urgency=medium

  * Add glstub.patch and fix FTBFS because NULL is not defined in glstub.c.
  * Drop B-D on python-pygccxml. (Closes: #943278)
  * Declare compliance with Debian Policy 4.4.1.
  * Use canonical VCS URI.
  * Switch to debhelper-compat = 12.

 -- Markus Koschany <apo@debian.org>  Thu, 26 Dec 2019 02:11:33 +0100

spring (104.0+dfsg-3) unstable; urgency=medium

  * Fix FTBFS with GCC-8. Add gcc-8.patch. (Closes: #906409)
  * Switch to compat level 11.
  * Declare compliance with Debian Policy 4.2.0.

 -- Markus Koschany <apo@debian.org>  Tue, 21 Aug 2018 18:12:59 +0200

spring (104.0+dfsg-2) unstable; urgency=medium

  * Move fonts-freefont-otf dependency from spring to spring-common.
    (Closes: #861042)
  * Add gold-linker.patch and fix FTBFS on i386.

 -- Markus Koschany <apo@debian.org>  Sat, 14 Oct 2017 18:27:26 +0200

spring (104.0+dfsg-1) unstable; urgency=medium

  * New upstream version 104.0+dfsg.
  * Declare compliance with Debian Policy 4.1.1.
  * Use https for Format field
  * Drop gold-linker.patch. Apparently no longer needed.
  * Refresh sdl-debian.patch
  * d/rules: Replace the old dh_install --list-missing override with
    dh_missing --fail-missing.
  * Fix spring.install and don't install non-existent bin files.
  * Override Lintian error license-problem-convert-utf-code.
    The license was changed and the new Unicode license is DFSG-free.
    See #864729 for more information.
  * Update debian/copyright for new release.
  * Purge the installer completely when repacking the tarball.
  * Update README.source about asio and gflags.
  * Ensure that we build against system libraries of minizip.

 -- Markus Koschany <apo@debian.org>  Sat, 14 Oct 2017 15:38:12 +0200

=== debian/control ===
Source: spring
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>
Build-Depends:
 asciidoc-base,
 bzip2,
 cmake,
 debhelper-compat (= 13),
 default-jdk,
 docbook-xml,
 docbook-xsl,
 libboost-all-dev,
 libcurl4-gnutls-dev,
 libdevil-dev,
 libfreetype6-dev,
 libglew-dev,
 libjna-java,
 libjsoncpp-dev,
 libminizip-dev,
 libogg-dev,
 libopenal-dev,
 libsdl2-dev,
 libunwind-dev,
 libvecmath-java,
 libvorbis-dev,
 libxcursor-dev,
 p7zip-full,
 xsltproc,
 zip
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/games-team/spring.git
Vcs-Browser: https://salsa.debian.org/games-team/spring
Homepage: https://springrts.com

Package: spring
Architecture: amd64 i386
Depends:
 spring-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 springlobby
Suggests:
 spring-javaai
Description: modern full-3D RTS game engine
 Spring is a modern full-3D RTS (Real Time Strategy) game engine originally
 created to bring the gameplay experience of Total Annihilation into 3D.
 Games are played using one of a number of mods.
 .
 This package just includes the game engine and the default AI, with no maps,
 mods or rich user interface.

Package: spring-common
Architecture: all
Depends:
 fonts-freefont-otf,
 ${misc:Depends}
Description: modern full-3D RTS game engine (common files)
 Spring is a modern full-3D RTS (Real Time Strategy) game engine originally
 created to bring the gameplay experience of Total Annihilation into 3D.
 Games are played using one of a number of mods.
 .
 This package just includes the game engine's arch independent files, with no
 maps, mods or rich user interface.

Package: spring-javaai
Architecture: all
Depends:
 default-jre | java7-runtime,
 libjna-java,
 libvecmath-java,
 spring (>= ${source:Version}),
 ${misc:Depends}
Description: modern full-3D RTS game engine (Java AIs)
 Spring is a modern full-3D RTS (Real Time Strategy) game engine originally
 created to bring the gameplay experience of Total Annihilation into 3D.
 Games are played using one of a number of mods.
 .
 This package contains Java based AIs and the spring interface libraries these
 require.
